/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package example.filesystem;

import org.apache.ws.resource.Resource;
import org.apache.ws.resource.ResourceContext;
import org.apache.ws.resource.ResourceContextException;
import org.apache.ws.resource.ResourceException;
import org.apache.ws.resource.ResourceKey;
import org.apache.ws.resource.ResourceUnknownException;
import org.apache.ws.resource.impl.AbstractResourceHome;

import java.io.Serializable;

/**
 * Home for FileSystem WS-Resources.
 * <p/>
 * NOTE: This class is generated and is NOT meant to be modified.
 *
 * @author Sal Campana, Ian P. Springer
 */
public class FileSystemHome
        extends AbstractResourceHome
        implements Serializable
{

    /**
     * DOCUMENT_ME
     *
     * @param resourceContext DOCUMENT_ME
     *
     * @return DOCUMENT_ME
     *
     * @throws ResourceException        DOCUMENT_ME
     * @throws ResourceContextException DOCUMENT_ME
     * @throws ResourceUnknownException DOCUMENT_ME
     */
    public Resource getInstance( ResourceContext resourceContext )
            throws ResourceException,
            ResourceContextException,
            ResourceUnknownException
    {
        ResourceKey key = resourceContext.getResourceKey();
        Resource resource = null;
        try
        {
            resource = find( key );
        }
        catch ( ResourceException re )
        {
            Object id = key.getValue();
            /**
             * Determine if the passed-in key is, in fact, something we expect.
             */
            if ( id.equals( "/dev/vg00/lvol1" ) || id.equals( "/dev/vg00/lvol2" ) )
            {
                try
                {
                    resource = createInstance( key);
                }
                catch ( Exception e )
                {
                    throw new ResourceException( e );
                }
                add( key, resource );
            }
            else
            {
                throw new ResourceUnknownException( id,
                        resourceContext.getServiceName() );
            }
        }
        return resource;
    }

}