/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package example.filesystem;

import org.apache.ws.resource.ResourceContext;
import org.apache.xmlbeans.XmlObject;
import org.apache.xmlbeans.XmlException;

import javax.xml.rpc.JAXRPCException;

/**
 * This class should be generated ONCE (and not overwritten) to maintain user-added code.
 * If there is a change to the WSDL, then the generated implemented interfaces
 * (representing the "base" portTypes) will change, thus showing a compile error to the
 * user.
 *
 * NOTE: This class is generated. However, it will not be overwritten by subsequent
 *       calls to the code generator.
 *
 * @author Ian P. Springer, Sal Campana
 */
public class FileSystemService
   extends AbstractFileSystemService
   implements FileSystemCustomOperationsPortType
{

   private ResourceContext m_resourceContext;

   /**
    * Creates a new {@link FileSystemService} object.
    *
    * @param resourceContext DOCUMENT_ME
    */
   public FileSystemService( ResourceContext resourceContext )
   {
      m_resourceContext = resourceContext;
      init(  );
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public ResourceContext getResourceContext(  )
   {
      return m_resourceContext;
   }

   public XmlObject mount( XmlObject requestDoc )
   {
      try
      {
         return XmlObject.Factory.parse( "<MountResponse />" );
      }
      catch ( XmlException xe )
      {
         throw new JAXRPCException( xe );
      }
   }

   public XmlObject unmount( XmlObject requestDoc )
   {
      try
      {
         return XmlObject.Factory.parse( "<UnmountResponse />" );
      }
      catch ( XmlException xe )
      {
         throw new JAXRPCException( xe );
      }
   }
}